<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import { NextStep } from '~/components/common/index.vue';
import { SolutionsResourceCards } from '~/components/solutions/index.vue';
import {
  CodeSuggestionsSalesContent,
  CodeSuggestionsSalesHero,
} from '~/components/solutions/code-suggestions/sales/index.vue';
import { CSSAlesHelper } from '~/services/solutions/code-suggestions-sales.service';

export default {
  name: 'CodeSuggestions',
  components: {
    NextStep,
    CodeSuggestionsSalesContent,
    CodeSuggestionsSalesHero,
    SolutionsResourceCards,
  },

  layout: 'code-suggestions-sale',
  nuxtI18n: false,

  async asyncData() {
    const content = await getClient()
      .getEntries({
        content_type: CONTENT_TYPES.PAGE,
        include: 10,
        'fields.slug': 'solutions/code-suggestions/sales',
      })
      .then((query: any) => {
        const entryFields = query.items[0]?.fields;
        return CSSAlesHelper(entryFields);
      })
      .catch((e) => {
        throw new Error('Error when generating page: ', e);
      });
    return { content };
  },
  data() {
    return {
      submitted: false,
    };
  },
  head(): MetaInfo {
    return {
      ...getPageMetadata((this as any).content, this.$route.path),
    };
  },
  methods: {
    onFormSubmit() {
      this.$nuxt.$emit('submit');
      this.submitted = true;
      this.$refs.targetRef.scrollIntoView({ behavior: 'smooth' });
    },
  },
};
</script>
<template>
  <div ref="targetRef" class="code-suggestions-sales">
    <TransitionGroup name="content" tag="div">
      <CodeSuggestionsSalesHero
        v-if="!submitted && content.hero"
        key="hero"
        :data="content.hero"
      />
      <CodeSuggestionsSalesContent
        v-if="!submitted && content.section"
        key="content"
        :data="content.section"
        :form="content.form"
        @submit="onFormSubmit"
      />
    </TransitionGroup>
    <TransitionGroup name="content" tag="div">
      <CodeSuggestionsSalesHero
        v-if="submitted && content.submittedHero"
        key="hero"
        :data="content.submittedHero"
      />
      <SolutionsResourceCards
        v-if="submitted && content.resources"
        v-bind="content.resources"
        key="resources"
      />
    </TransitionGroup>
    <NextStep :variant="content?.nextSteps" />
  </div>
</template>

<style lang="scss" scoped>
.code-suggestions-sales {
  overflow: hidden;
}
.content-move, /* apply transition to moving elements */
.content-enter-active,
.content-leave-active {
  transition: all 0.5s ease;
}

.content-enter-from,
.content-leave-to {
  opacity: 0;
}
.content-leave-to {
  transform: translateY(100%);
}
/* ensure leaving items are taken out of layout flow so that moving
   animations can be calculated correctly. */
.content-leave-active {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
}
</style>
